
var fg_Debug = false;
//Real - servidor
var fg_Delta = 0;
var fg_Galaxy = 1;
var fg_System = 1;
var fg_Planet = 1;
var fg_StoredCoord = false;

var messages = srGetStrBundle("chrome://foxgame/locale/foxgame.properties");


function fg_newDate2(mode) 
{
	var date = new Date();

	if (mode == 0) //Hora cliente
		return date;
	if (mode == 1) //Hora servidor
	{
		date.setTime(date.getTime() - fg_Delta);
		return date;
	}
	if (mode == 2) //Hora cliente minutos y segundos servidor
	{
		var horas = 1000 * 60 * 60;
		var diff = 0;
		if (fg_Delta < 0)
			diff = -((- fg_Delta) % horas);
		else
			diff = fg_Delta % horas;
		date.setTime(date.getTime() - diff);
		return date;			
	}
	if (mode == 3) //Hora servidor + differencia
	{
		try {
			var diff = parseInt(PrefsBranchFG.getCharPref("fgTimeDiff"));
		} catch (e) {
			var diff = -4;
		}

		var horas = 1000 * 60 * 60;
		diff = diff * horas;
		date.setTime(date.getTime() - fg_Delta + diff);
		return date;			
	}


}
function fg_newDate() {
	
	try {
		var mode = parseInt(PrefsBranchFG.getCharPref("fgTimeMode"));
	} catch (e) {
		var mode = 1;
	}
	return fg_newDate2(mode);
}

function fg_addJavaScript(doc, js) {
    
  var head = doc.getElementsByTagName("head")[0];    

  var script = doc.createElement("script");
  script.setAttribute("language", "JavaScript");
  script.setAttribute("src", js);
  head.appendChild(script);
  
  return script;
    
}

function fg_addFormat(str) {
	str += '';
	var rgx = /(\d+)(\d{3})/;
	while (rgx.test(str)) {
		str = str.replace(rgx, '$1' + '.' + '$2');
	}
	return str;
}

function fg_addFiring(doc, func) {

  var head = doc.getElementsByTagName("head")[0];    

  var script = doc.createElement("script");
  script.setAttribute("language", "JavaScript");
  script.innerHTML = 'function fire(){'+
	'window.removeEventListener("mousemove", fire, true);'+
	func+'();'+
	'}'+
	'window.addEventListener("mousemove", fire, true);';
  head.appendChild(script);


}

function fgEvalnode(path,document,node) {
	var ret = document.evaluate(path,node,null,
			XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (fg_Debug) alert(ret.snapshotLength);

	return ret;

}

function fgEval(path,document) {
	return fgEvalnode(path,document,document);
}

function fg_isOGameDomain(href) {

    if (href.match(/^file:\/\//) && fg_Debug) return true;
          
     var sites = new Array(/^http:\/\/(.*\.)?ogame\d*\.de/i,
				/^http:\/\/s\d+\.gfsrv\.net/i,
				/^http:\/\/213\.239\.220\.37/i,
				/^http:\/\/213\.239\.213\.168/i,
				/^http:\/\/213\.239\.213\.169/i,
				/^http:\/\/213\.239\.215\.75/i,
				/^http:\/\/213\.239\.217\.140/i,
				/^http:\/\/game\d+\.de/i,
				/^http:\/\/.*\.ogamed*\.de\.es/i,
				/^http:\/\/(.*\.)?ogame\d+\.tiscali\.de/i,
				/^http:\/\/(.*\.)?ogame\.com\.es/i,
				/^http:\/\/(.*\.)?ogame\.de/i,
				/^http:\/\/(.*\.)?ogame\.fr/i,
				/^http:\/\/(.*\.)?ogame\.pl/i,
				/^http:\/\/(.*\.)?ogame\.nl/i,
				/^http:\/\/(.*\.)?ogame\.dk/i,
				/^http:\/\/(.*\.)?ogame\.it/i,
				/^http:\/\/(.*\.)?ogame\.ru/i,
				/^http:\/\/(.*\.)?ogame\.sk/i,
				/^http:\/\/(.*\.)?ogame\.ba/i,
				/^http:\/\/(.*\.)?ogame\.com\.hr/i,
				/^http:\/\/(.*\.)?ogame\.com\.tw/i,
				/^http:\/\/(.*\.)?ogame\.com\.br/i,
				/^http:\/\/(.*\.)?ogame\.com\.pt/i,
				/^http:\/\/(.*\.)?ogame\.com\.tr/i,
				/^http:\/\/(.*\.)?ogame\.org/i);
            
     for (var i = 0; i< sites.length; i++) {
        if (href.search(sites[i]) > -1) {
          return true;   
        } 
     }    
     return false;
}

function fg_adjustPages(event)	{
    
       var doc = event.originalTarget;
       
       try {
           if (doc.nodeType != doc.DOCUMENT_NODE) 
                doc = doc.ownerDocument;
		
		var href = doc.location.href;     
		if (fg_isOGameDomain(href)) {
			var functions = new Array(
				fg_getDelta,
				fg_selectUniverse,
				fg_addFlotaTime,
				fg_replicateOptions,
				fg_addFlotaReturnTime,
				fg_addReportButtons,
				fg_addMilosButtons,
				fg_addRankingButtons,
				fg_addDebrisImage,
				fg_removePlanets,
				fg_colorizePrivates,
				fg_colorizeAlly,
				fg_addBuildingsTime,
				fg_addResearchTime,
				fg_addPhalanxTime,
				fg_addOverviewTime,
				fg_addBuildingTime,
				fg_addSignature,
				fg_pasteCoords,
				fg_infosDeltas,
				//fg_buildDeltas,
				fg_selectMission
			);
			callOgameFunctions(functions, doc);
		}
	} catch (e) {
		foxgameDebug(e);
	}

}

function callOgameFunction(func, doc) {
    try {
        func(doc);   
    } catch (e) {
        foxgamedebug(e);
    }
}

function callOgameFunctions(funcs, doc) {
    
    for (var i=0; i<funcs.length; i++) {
        callOgameFunction(funcs[i], doc);
    }
    
}

function fg_initPopupMenu(event) {
    try {    
    	if (event.target.id != "contentAreaContextMenu") return;

//	gContextMenu.showItem("foxgame-config-menu",fg_isOGameDomain(window._content.document.location.href));

   	var fgMenu = document.getElementById("foxgame-config-menu");

//	dump(isOGameDomain(window._content.document.location.href)+"\n");

	fgMenu.setAttribute("hidden",!fg_isOGameDomain(window._content.document.location.href));

//	fgMenu.setAttribute("collapsed",!isOGameDomain(window._content.document.location.href));
//	fgMenu.hidden = !isOGameDomain(window._content.document.location.href);
//	fgMenu.collapsed = !isOGameDomain(window._content.document.location.href);
//	dump(fgMenu.hidden+"\n");

	return;
    } catch (e){
        foxgamedebug(e);
    }

}

function fg_isLoginUrl(href) {
    return href.search(/portal\//i) > -1;
}

function fg_isFlota2Url(href) {
	return href.search(/flotten2\.php/i) > -1;
}

function fg_isFlota3Url(href) {
	return href.search(/flotten3\.php/i) > -1;
}

function fg_isFlotaUrl(href) {
	return href.search(/flotten1\.php/i) > -1;
}

function fg_isGalaxyUrl(href) {
	return href.search(/galaxy\.php/i) > -1;
}

function fg_isMessagesUrl(href) {
	return href.search(/\/messages\.php/i) > -1;
}

function fg_isBuildingsUrl(href) {
	return href.search(/\/buildings\.php/i) > -1;
}

function fg_isBuildings2Url(href) {
	return href.search(/\/b_building\.php/i) > -1;
}

function fg_isOverviewUrl(href) {
	return href.search(/\/overview\.php/i) > -1;
}

function fg_isPhalanxUrl(href) {
	return href.search(/\/phalanx\.php/i) > -1;
}

function fg_isWriteMessagesUrl(href) {
	return href.search(/\/writemessages\.php/i) > -1;
}

function fg_isInfosUrl(href) {
	return href.search(/\/infos\.php/i) > -1;
}

function fg_isStatUrl(href) {
	return href.search(/\/stat\.php/i) > -1;
}

function fg_isCoord(str) {
	if (str.search(/[>\s\[\(](\d{1,2})[:\.\-\/\s](\d{1,3})[:\.\-\/\s](\d{1,2})[\s\]\)<,\.]/gi) != -1) return true;
	if (str.search(/^(\d{1,2})[:\.\-\/\s](\d{1,3})[:\.\-\/\s](\d{1,2})[\s\]\)<,\.]/gi) != -1) return true;
	if (str.search(/[>\s\[\(](\d{1,2})[:\.\-\/\s](\d{1,3})[:\.\-\/\s](\d{1,2})$/gi) != -1) return true;
	if (str.search(/^(\d{1,2})[:\.\-\/\s](\d{1,3})[:\.\-\/\s](\d{1,2})$/gi) != -1) return true;
	return false;
}

function fg_selectUniverse(doc) {

	if (doc && !fg_isLoginUrl(doc.location.href)) return;
	if (!fgGetBooleanPref("foxgameSelectUniverse",true)) return;

	try {
		if (doc.location.href.indexOf(PrefsBranchFG.getCharPref("fgServer")) == -1) return;
	} catch(e){ return;}

	if (fg_Debug) alert("Estamos Universo");

	try {
		var uni = PrefsBranchFG.getCharPref("fgUni");
	} catch(e) { return;}
	var univeroption = doc.evaluate( 
		'//option[@value="'+uni+'"]', doc, null, 					
		XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

	if (univeroption.snapshotLength == 0) return;

	univeroption.snapshotItem(0).selected = true;
}

function fgFindParentDocument(document) {
	try {
		var l = gBrowser.mPanelContainer.childNodes.length;
		var found = false;
		for(var i = 0; i < l; i++) {
			var b = gBrowser.getBrowserAtIndex(i);
			if (fg_isOGameDomain(b.currentURI.spec)) 
			{
				var frames = b.contentDocument.getElementsByTagName("frame");
				if(frames.length > 1 && (frames[1].contentDocument == document))
				{
					return b.contentDocument;
				}
			}
		}
		return null;
	} catch(e){
		foxgamedebug(e);
		return null;
	}	
}

function fg_addBuildingTime(document) {

	if (document && !fg_isBuildingsUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameBuildingTime",true)) return;

	if (fg_Debug) alert("Estamos tiempo hangar");

	try {
	      var path = '//form/form';
      	var obj = fgEval(path,document);

		if (obj.snapshotLength == 0) return;

		obj = obj.snapshotItem(0);
		while(obj.nodeName != "#text")
			obj = obj.nextSibling;
		var text = obj.nodeValue;
		text = text.split(':');
		text = text[1].trim();
		text = text.split(/\s+/);
		var sec = 0, temp = 0;
		for (var i = 0; i < text.length; i++) {	
			text[i]=text[i].replace(/^\s*0(.*)/, "$1");
			temp = parseInt(text[i]);
			if (i == 0 && text.length == 8)
				sec = sec + (temp * 86400);
			else if ((i == 0 && text.length == 6) || (i == 2 && text.length == 8))
				sec = sec + (temp * 3600);
			else if ((i == 0 && text.length == 4) || (i == 2 && text.length == 6) || (i == 4 && text.length == 8))
				sec = sec + (temp * 60);
			else if ((i == 2 && text.length == 4) || (i == 4 && text.length == 6) || (i == 6 && text.length == 8))
				sec = sec + temp;
			i++;
		}
		var date = fg_newDate();
		date.setTime(date.getTime() + (sec*1000));
		var date2 = fg_newDate();
		var text2;
		if (date.getDate() != date2.getDate())
			text2 = document.createTextNode(messages.GetStringFromName("foxgame.inner.finishTime") + " : " + formatDate(date,"d/MM H:mm:ss"));
		else
			text2 = document.createTextNode(messages.GetStringFromName("foxgame.inner.finishTime") + " : " + formatDate(date,"H:mm:ss"));
		br = document.createElement("br");
		obj.parentNode.appendChild(br);
		obj.parentNode.appendChild(text2);
		
	} catch (e) {
		foxgamedebug(e);
	}
}

function fg_addResearchTime(document) {

	if (document && !fg_isBuildingsUrl(document.location.href))  return;
	if (!fgGetBooleanPref("foxgameResearchTime",true)) return; 
	
	if (fg_Debug) alert("Estamos tiempo investigacion");

	setTimeout(function(){
		fg_addBxxTime(document);
	},200);
}

function fg_addBuildingsTime(document) {

	if (document && !fg_isBuildings2Url(document.location.href))  return;
	if (!fgGetBooleanPref("foxgameBuildingsTime",true)) return; 
	
	if (fg_Debug) alert("Estamos tiempo construccion");

	fg_addBxxTime(document);
}

function fg_addPhalanxTime(document) {

	if (document && !fg_isPhalanxUrl(document.location.href))  return;
	if (!fgGetBooleanPref("foxgamePhalanxTime",true)) return; 
	
	if (fg_Debug) alert("Estamos tiempo phalanx");

	setTimeout(function(){
		fg_addBxxTime(document);
	},200);
}

function fg_addBxxTime(document) {

	try {
	      var path = '//div[starts-with(@id,"bxx")]';
      	var obj = fgEval(path,document);


		var date, date2 = fg_newDate();
		var secs;
		var ele;
		var text;
		for (var i = 0; i < obj.snapshotLength; i++) {
			ele = obj.snapshotItem(i);
			text = ele.firstChild.nodeValue.split(':');
			secs = parseInt(text[0].replace(/^\s0(.*)/, "$1")) * 3600;
			secs = secs + parseInt(text[1].replace(/^\s0(.*)/, "$1")) * 60;
			secs = secs + parseInt(text[2].replace(/^\s0(.*)/, "$1"));

			date = fg_newDate();
			date.setTime(date.getTime() + (secs*1000));

			var text2;
			if (date.getDate() != date2.getDate())
				text2 = document.createTextNode(formatDate(date,"d/MM H:mm:ss"));
			else
				text2 = document.createTextNode(formatDate(date,"H:mm:ss"));
			var font = document.createElement("strong");
			font.innerHTML = "<br /><font color='lime'>" +text2.nodeValue+"</font>";
			font.setAttribute("color","lime");
			ele.parentNode.appendChild(font);
		}

	} catch (e) {
		setTimeout(function(){
			fg_addBxxTime(document);
		},100);
	}

}

function fg_getDelta(document) {

	if (document && !fg_isOverviewUrl(document.location.href)) return;
	
	if (fg_Debug) alert("Estamos obtener delta");

	try {
		var date = new Date();
	      var path = '//table/tbody/tr/th[@colspan="3"][1]';
      	var obj = fgEval(path,document);
		if (obj.snapshotLength == 0) return;
		obj = obj.snapshotItem(0);
		obj = obj.innerHTML;
		var startTime = getDateFromFormat(obj + " " + (1900+date.getYear()),"E MMM d H:m:s y");
		fg_Delta = date.getTime() - startTime;
	}catch(e) {
		foxgamedebug(e);
	}
}

function fg_addOverviewTime(document) {

	if (document && !fg_isOverviewUrl(document.location.href)) return;
	
	if (fg_Debug) alert("Estamos tiempo vision");

	try {
	      var path = '//div[starts-with(@id,"bxx")]';
      	var obj = fgEval(path,document);


		var date, date2 = fg_newDate();
		var secs;
		var ele;
		for (var i = 0; i < obj.snapshotLength; i++) {
			ele = obj.snapshotItem(i);
			secs = parseInt(ele.getAttribute("title"));
			date = fg_newDate();
			date.setTime(date.getTime() + (secs*1000));

			var text2;
			if (date.getDate() != date2.getDate())
				text2 = document.createTextNode(formatDate(date,"d/MM H:mm:ss"));
			else
				text2 = document.createTextNode(formatDate(date,"H:mm:ss"));
			var font = document.createElement("font");
			font.setAttribute("color","lime");
			font.appendChild(text2);
			if (fgGetBooleanPref("foxgameAddOverviewTime",false)) 
				ele.parentNode.appendChild(font);
			if (fgGetBooleanPref("foxgameRemoveOverviewTime",true))
				ele.parentNode.removeChild(ele);
		}

	} catch (e) {
		foxgamedebug(e);
	}
}

function fg_addKeyNavigation(document) {

	if (document && !isGalaxyUrl(fg_document.location.href)) return;
	if (!fgGetBooleanPref("foxgameKeyNavigation",true)) return;

	
	if (fg_Debug) alert("Estamos teclado");

	//Insertamos el .js con la funcion de navegacion por teclado
	addJavaScript(document, "chrome://foxgame/content/resources/js/keyGalaxy.js");

}

function fg_addDebrisImage(document) {

	if (document && !fg_isGalaxyUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameHighlightBigDebris",true)) return;	

	if (fg_Debug) alert("Estamos escombros");

	try {

	      var path = '//table[@width="569"]/child::tbody/descendant::tr/child::th[1]/child::a[2]';
      	var obj = fgEval(path,document);

		try {
			var color = PrefsBranchFG.getCharPref("fgDebrisColor");
		} catch(e) { var color ="#AA3333";}

		try {
			var min = PrefsBranchFG.getCharPref("fgDebrisMin");
		} catch(e) { var min ="20000";}

		min = parseInt(min.replace(/[\.,]/i,''));

		var title, metal, cristal;
		for (var i = 0; i < obj.snapshotLength; i++) {
			obj2 = obj.snapshotItem(i);
			title = obj2.getAttribute("title");
			title = title.split(':');
			metal = title[2].split(',');
			metal = metal[0].replace(/[\s\.]/gi,'');
			cristal = title[3].replace(/[\s\.]/gi,'');

			if (parseInt(metal) + parseInt(cristal) >= min) {
				obj2.parentNode.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.nextSibling.setAttribute("style", "background-color : "+color+"; background-image : none;");
			}	
		}
	} catch (e) {
		foxgamedebug(e);
	}
}

function fg_removePlanets(document) {
	
	if (document && !fg_isGalaxyUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameRemovePlanets",true)) return;
	
	if (fg_Debug) alert("Estamos planets");
	

	try {
	      var path = '//table[@width="569"]/child::tbody/child::tr/child::th[position()=2]';
      	var obj = fgEval(path,document);		
	
		if (obj.snapshotLength == 0) return;

		var text;
		for (var i = 0; i < obj.snapshotLength; i++) {
			if (obj.snapshotItem(i).firstChild.nextSibling != null) {
				text = obj.snapshotItem(i).nextSibling.nextSibling.innerHTML;			
				obj.snapshotItem(i).nextSibling.nextSibling.innerHTML = "";
				obj.snapshotItem(i).nextSibling.nextSibling.appendChild(
					obj.snapshotItem(i).removeChild(obj.snapshotItem(i).firstChild.nextSibling));
				obj.snapshotItem(i).nextSibling.nextSibling.firstChild.innerHTML = text;
			}
			
			obj.snapshotItem(i).parentNode.removeChild(obj.snapshotItem(i));
		}

	      path = '//table[@width="569"]/descendant::td[@class="c"][position()=2]';
      	obj = fgEval(path,document);		
		
		for (var i = 0; i < obj.snapshotLength; i++) {
			if (i == 0) {
				text = obj.snapshotItem(i).innerHTML;
				obj.snapshotItem(i).nextSibling.nextSibling.innerHTML = text;
			}
			obj.snapshotItem(i).parentNode.removeChild(obj.snapshotItem(i));
		}

	      path = '//table[@width="569"]/descendant::td[@class="c"][position()=5]';
      	obj = fgEval(path,document);
		obj.snapshotItem(0).innerHTML = messages.GetStringFromName("foxgame.inner.reducedDebris");
		

	      path = '//table[@width="569"]/descendant::td[@class="c"][@colspan="8"]';
		obj = fgEval(path,document);
		for (var i = 0; i < obj.snapshotLength; i++) {
			obj.snapshotItem(i).setAttribute("colspan","7");
		}
	      path = '//table[@width="569"]/descendant::td[@class="c"][@colspan="6"]';
		obj = fgEval(path,document);
		for (var i = 0; i < obj.snapshotLength; i++) {
			obj.snapshotItem(i).setAttribute("colspan","5");
		}

	} catch (e) {
		foxgamedebug(e);
	}
}

function fg_colorizePrivates(document) {

	if (document && !fg_isMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameHighlightPrivates",true)) return;

	
	if (fg_Debug) alert("Estamos privados");
	
	try {

		var path = '//table/tbody/tr/th[4]/child::a/img[@alt!=""]';
		var obj = fgEval(path,document);
		try {
			var color = PrefsBranchFG.getCharPref("fgPrivateColor");
		} catch(e) { var color ="#AA3333";}

		for (var i = 0; i < obj.snapshotLength; i++)
		{	
				
			obj2 = obj.snapshotItem(i).parentNode.parentNode.parentNode;
			var nodes = obj2.childNodes;			
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+color+"; background-image : none;");
			}
			nodes = obj2.nextSibling.nextSibling.childNodes;
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+color+"; background-image : none;");
			}

		}

	} catch (e) {
		foxgamedebug(e);
	}
}

function fg_colorizeAlly(document) {

	if (document && !fg_isMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameHighlightAllyMessages",true)) return;

	
	if (fg_Debug) alert("Estamos alianza");
	
	try {

		var path = '//table/tbody/tr/th[3]';
		var obj = fgEval(path,document);
		try {
			var color = PrefsBranchFG.getCharPref("fgAllyColor");
		} catch(e) { var color ="#AA3333";}

		for (var i = 0; i < obj.snapshotLength; i++)
		{		
			var subject = obj.snapshotItem(i).innerHTML;
			found = subject.match(/\[.*\]/);
			if (!found) continue;
			if (fg_isCoord(found[0])) continue;
			obj2 = obj.snapshotItem(i).parentNode;
			var nodes = obj2.childNodes;			
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+color+"; background-image : none;");
			}
			nodes = obj2.nextSibling.nextSibling.childNodes;
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+color+"; background-image : none;");
			}

		}

	} catch (e) {
		foxgamedebug(e);
	}
}

function fg_replicateOptions(document) {

	if (document && !fg_isMessagesUrl(document.location.href)) return;
	
	if (fg_Debug) alert("Estamos replicado de opciones");
	
	try {
		if (fgGetBooleanPref("foxgameReplicateSpyReportOptions",false)) 
		{

			var path = '//table/tbody/tr/th/input[@name="fullreports"]';
			var row = fgEval(path,document);
			if (row.snapshotLength == 0) return;
			row = row.snapshotItem(0).parentNode.parentNode;
			var row2 = row.cloneNode(true);
			row.firstChild.nextSibling.firstChild.setAttribute("id","fullreports");
			row.firstChild.nextSibling.firstChild.setAttribute("onchange","document.getElementById('fullreports2').checked=this.checked");

			row2.firstChild.nextSibling.firstChild.setAttribute("name","fullreports2");
			row2.firstChild.nextSibling.firstChild.setAttribute("id","fullreports2");
			row2.firstChild.nextSibling.firstChild.setAttribute("onchange","document.getElementById('fullreports').checked=this.checked");
			row.parentNode.insertBefore(row2,row.parentNode.firstChild);

		} 
		if (fgGetBooleanPref("foxgameReplicateDeleteOptions",true)) 
		{

			var path = '//table/tbody/tr/th/select[@name="deletemessages"]';
			var row = fgEval(path,document);
			if (row.snapshotLength == 0) return;
			row = row.snapshotItem(0).parentNode.parentNode;
			var row2 = row.cloneNode(true);
			row.firstChild.nextSibling.firstChild.nextSibling.setAttribute("id","deletemessages");
			row.firstChild.nextSibling.firstChild.nextSibling.setAttribute("onchange","document.getElementById('deletemessages2').options[this.selectedIndex].selected='true'");
	
			row2.firstChild.nextSibling.firstChild.nextSibling.setAttribute("name","deletemessages2");
			row2.firstChild.nextSibling.firstChild.nextSibling.setAttribute("id","deletemessages2");
			row2.firstChild.nextSibling.firstChild.nextSibling.setAttribute("onchange","document.getElementById('deletemessages').options[this.selectedIndex].selected='true'");
			row.parentNode.insertBefore(row2,row.parentNode.firstChild);
		
		}
		//Recolocamos el formulario para que el arbol tenga una estructura correcta
	
		var table = fgEval( 
			'//input[@name="messages"]', document)
		if (table.snapshotLength == 0) return;
		table = table.snapshotItem(0).parentNode.parentNode.parentNode.parentNode;
		var form = fgEval (
			'//form[starts-with(@action,"messages")]', document).snapshotItem(0);
		if (form.snapshotLength == 0) return;
		form = form.parentNode.removeChild(form);

		table.parentNode.replaceChild(form,table);
		form.appendChild(table);

	} catch (e) {
		foxgamedebug(e);
	}
}

String.prototype.trim = function() {
  var x=this;
  x=x.replace(/^\s*(.*)/, "$1");
  x=x.replace(/(.*?)\s*$/, "$1");
  return x;
}

String.prototype.retrim = function() {

  var x=this.trim();
  x=x.replace(/(.*)\s*(.*)/g, "$1 $2");
  return x;
}

function fg_addRankingButtons(document) {
	if (document && !fg_isStatUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameAddStatButtons",false)) return;

	
	if (fg_Debug) alert("Estamos milos ranking");
	
	try {
//Insertamos el .js con la funcion de envio del formulario

	fg_addJavaScript(document, "chrome://foxgame/content/resources/js/milosStat.js");

// Generamos un formulario para enviar la galaxia a MILOS directamente

      var path = '//table[@width="519"]';
      var obj = fgEval(path,document);

	if (obj.snapshotLength < 2) return;
	var i = fg_loadDBs(document);	
	if (i == null) return;
	var ele = fg_listaDBs.data[i];
	var text = "";

	if (ele.type != "GalaxieTool") {
		obj = obj.snapshotItem(1);
		var tr = obj.firstChild.nextSibling.firstChild;
      	var range = document.createRange();
		var td_true = false;
		while (tr != null)
	 	{
			if (tr.nodeName == 'TR') {
				td = tr.firstChild;
				while (td != null) {
					if (td.nodeName == 'TD' || td.nodeName == 'TH')
					{
					      range.selectNode(td);
						var temp = range.toString();
						temp = temp.retrim();
						if (temp == "")
							temp = " ";
						if (td.nodeName == 'TD') {
							td_true = true;
							text +=  temp +"  \t";
						} else {
							td_true = false;
							text +=  temp +" \t";
						}
					}
					td = td.nextSibling;
				}
				if (!td_true)
					text = text.substr(0,text.length-2)+"\r\n";
				else 
					text = text.substr(0,text.length-3)+"\r\n";
			}
			tr = tr.nextSibling;
		}
		range.detach;
		var div = document.createElement('p');
		div.innerHTML = text;
		texto = div.innerHTML.replace(/&nbsp;/gi," ");
	} else {
		texto = obj.snapshotItem(1).innerHTML;
		texto = texto.replace(/'/ig,"");
	}
	

	//Insertamos un formulario para poder enviar los datos directamente.	
	var form = document.createElement('tr');
	var td = document.createElement('td');
	td.setAttribute("colspan","8");
	td.setAttribute("class","1");
	td.setAttribute("align","center");
	td.setAttribute("valign","middle");
	td.innerHTML = 
	"<div style=\"position:absolute; z-index:1; top:100px; left:50px; visibility: hidden\" id=\"div_frame\">"+
	'<table celspacing="0" celpadding="0"><tr><td align="right"><a onclick="hide()">'+messages.GetStringFromName("foxgame.inner.close") +'</a></td></tr><tr><td>'+
	"<iframe src=\"\" name=\"_milos\"id=\"_milos\" height=\"300\" width=\"600\"></iframe>"+
	'</td></tr></table></div>';
	if (ele.type == "Milos") {
		if (document.getElementsByName("who")[0].value != "ally") return;
		if (document.getElementsByName("type")[0].value != "pts") return;

		var temp = ele.other.split("[]");
		td.innerHTML += '<form action="http://milos.nethen.org/milos-paste/#" method=post target="_milos" id="milos_form">'+
			'<input type=hidden name="milos_login[user]" value="'+temp[0]+'">'+
			'<input type=hidden name="milos_login[passwd]" value="'+temp[1]+'">'+
			'<input type=hidden name="milos_login[group]" value="'+temp[2]+'">'+
			'<input type=hidden name="milos_login[sg]" value="'+temp[3]+'">'+
			'<input type=hidden name="milos_login[r]" value="">'+
			'<input type=hidden name="show" value="checked">'+
			'<input type=hidden name="noncommit" value="">'+
			'<input type=hidden name="delafter" value="checked">'+
			'<input type=hidden name=x value="'+texto+'">';
	}
	else if (ele.type == "EspRep") {
		if (document.getElementsByName("type")[0].value != "pts") return;

		td.innerHTML += '<form action="http://www.esprep.org/general/dump.php?quick=1" method=post target="_milos" id="milos_form" accept-charset="utf-8">'+
			'<input type=hidden name="show" value="Process Dump (Show Results)">'+
			'<input type="hidden" name="espplayer" value="none">'+
			'<input type="hidden" name="espalliance" value="none">'+
			'<input type=hidden name=dump value="'+texto+'">';
	}
	else if(ele.type == "GalaxieTool") {
			var temp = ele.other.split("[]");
			td.innerHTML += '<form action="'+temp[2]+'" method=post target="_milos" id="milos_form">'+
				'<input type=hidden name="user" value="'+temp[0]+'">'+
				'<input type=hidden name="password" value="'+temp[1]+'">'+
				'<input type=hidden name="typ" value="stats">'+
				'<input type=hidden name="who" value="'+document.getElementsByName("who")[0].selectedIndex+'">'+
				'<input type=hidden name="what" value="'+document.getElementsByName("type")[0].selectedIndex+'">'+
				//'<textarea name=content rows=1 cols=75>'+texto+'</textarea>';
				"<input type=hidden name='content' value='"+texto+"'>";		
	}
	td.innerHTML += "<input type=button value=\"&lt;- "+ele.type+"\" onClick=\"next('l:"+ele.type+"')\">"+
	"<input type=button value=\""+ele.type+"\" onClick=\"next('1:"+ele.type+"')\">"+
	"<input type=button value=\""+ele.type+" -&gt;\" onClick=\"next('r:"+ele.type+"')\">";
		
	form.appendChild(td);

	var tds = fgEval('//table[@width="519"]/child::tbody', document).snapshotItem(0);
	tds.insertBefore(form,tds.firstChild);	

	} catch (e) {
		foxgamedebug(e);
	}
}

function fg_loadDBs(document){
	fg_listaDBs.load();
	var found = false;
	var i;
	for (i = 0; i < fg_listaDBs.data.length; i++) {
		if (document.location.href.indexOf(fg_listaDBs.data[i].uni) != -1) {
			found = true;
			break;
		}
	}
	if (found == false)
		return null;
	return i;
}

function fg_addMilosButtons(document) {

	if (document && !fg_isGalaxyUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameAddMilosButtons",false)) return;
	
	if (fg_Debug) alert("Estamos milos");
	
	try {
//Insertamos el .js con la funcion de envio del formulario
	fg_addJavaScript(document, "chrome://foxgame/content/resources/js/milosGalaxy.js");

// Generamos un formulario para enviar la galaxia a MILOS directamente

      var path = '//table[@width="569"]';
      var obj = fgEval(path,document);

	if (obj.snapshotLength == 0) return;
		
	var i = fg_loadDBs(document);	
	if (i == null) return;
	var ele = fg_listaDBs.data[i];
	var text = "";

	if (ele.type != "GalaxieTool") {
		obj = obj.snapshotItem(0);
		var tr = obj.firstChild.nextSibling.firstChild;
      	var range = document.createRange();
	
		while (tr != null)
	 	{
			if (tr.nodeName == 'TR') {
				td = tr.firstChild;
				while (td != null) {
					if (td.nodeName == 'TD' || td.nodeName == 'TH')
					{
							var a = fgEvalnode('.//img[contains(@alt,"M")]',document,td);
							if (a.snapshotLength > 0) 
								text += "M \t";
							else {
							      range.selectNode(td);
								text += range.toString().retrim()+" \t";
							}
					}
					td = td.nextSibling;
				}
				text = text.substr(0,text.length-2)+"\n";
			}
			tr = tr.nextSibling;
		}
		range.detach;
		texto = text;
	} else {
		texto = obj.snapshotItem(0).innerHTML;

		texto = texto.replace(/'/ig,"");
	}
	

	//Insertamos un formulario para poder enviar los datos directamente.	
	var form = document.createElement('tr');
	var td = document.createElement('td');
	td.setAttribute("colspan","8");
	td.setAttribute("class","1");
	td.setAttribute("align","center");
	td.setAttribute("valign","middle");
	td.innerHTML = 
	"<div style=\"position:absolute; z-index:1; top:100px; left:50px; visibility: hidden\" id=\"div_frame\">"+
	'<table celspacing="0" celpadding="0"><tr><td align="right"><a onclick="hide()">'+messages.GetStringFromName("foxgame.inner.close") +'</a></td></tr><tr><td>'+
	"<iframe src=\"\" name=\"_milos\"id=\"_milos\" height=\"300\" width=\"600\"></iframe>"+
	'</td></tr></table></div>';
	if (ele.type == "Milos") {
			var temp = ele.other.split("[]");
			td.innerHTML += '<form action="http://milos.nethen.org/milos-paste/#" method=post target="_milos" id="milos_form">'+
				'<input type=hidden name="milos_login[user]" value="'+temp[0]+'">'+
				'<input type=hidden name="milos_login[passwd]" value="'+temp[1]+'">'+
				'<input type=hidden name="milos_login[group]" value="'+temp[2]+'">'+
				'<input type=hidden name="milos_login[sg]" value="'+temp[3]+'">'+
				'<input type=hidden name="milos_login[r]" value="">'+
				'<input type=hidden name="show" value="checked">'+
				'<input type=hidden name="noncommit" value="">'+
				'<input type=hidden name="delafter" value="checked">'+
				'<input type=hidden name=x value="'+texto+'">';
	}
	else if (ele.type == "EspRep") {
			td.innerHTML += '<form action="http://www.esprep.org/general/dump.php?quick=1" method=post target="_milos" id="milos_form" accept-charset="utf-8">'+
				'<input type=hidden name="show" value="Process Dump (Show Results)">'+
				'<input type="hidden" name="espplayer" value="none">'+
				'<input type="hidden" name="espalliance" value="none">'+
				'<input type=hidden name=dump value="'+texto+'">';
	}
	else if(ele.type == "GalaxieTool") {
			var temp = ele.other.split("[]");
			td.innerHTML += '<form action="'+temp[2]+'" method=post target="_milos" id="milos_form">'+
				'<input type=hidden name="user" value="'+temp[0]+'">'+
				'<input type=hidden name="password" value="'+temp[1]+'">'+
				'<input type=hidden name="typ" value="galaxy">'+
				'<input type=hidden name="galaxy" value="'+document.getElementsByName("galaxy")[0].value+'">'+
				'<input type=hidden name="system" value="'+document.getElementsByName("system")[0].value+'">'+
				//'<textarea name=content rows=1 cols=75>'+texto+'</textarea>';
				"<input type=hidden name='content' value='"+texto+"'>";		
	}
	td.innerHTML += "<input type=button value=\"&lt;- "+ele.type+"\" onClick=\"next('l:"+ele.type+"')\">"+
	"<input type=button value=\""+ele.type+"\" onClick=\"next('1:"+ele.type+"')\">"+
	"<input type=button value=\""+ele.type+" -&gt;\" onClick=\"next('r:"+ele.type+"')\">";
		
	form.appendChild(td);

	var tds = fgEval('//table[@width="569"]/descendant::td[@colspan="2"][@class="c"][last()]', document).snapshotItem(0);
	tds.parentNode.parentNode.appendChild(form);	

	} catch (e) {
		foxgamedebug(e);
	}
}

function fg_addReportButtons(document) {

	if (document && !fg_isMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameAddReportButtons",false)) return;

	if (fg_Debug) alert("Estamos milos");
	
	try {

	var i = fg_loadDBs(document);	
	if (i == null) return;
	var ele = fg_listaDBs.data[i];

	//Insertamos el .js con la funcion de envio del formulario
	fg_addJavaScript(document, "chrome://foxgame/content/resources/js/milosReport.js");

	//Insertamos un formulario para poder enviar los datos directamente.	
	var div = document.createElement('div');
	div.setAttribute('style',"position:absolute; z-index:1; top:100px; left:50px; visibility: hidden");
	div.setAttribute('id',"div_frame");
	div.innerHTML = "<table celspacing=\"0\" celpadding=\"0\"><tr><td align=\"right\"><a onclick=\"hide();\">"+messages.GetStringFromName("foxgame.inner.close") +'</a></td></tr><tr><td>'+
	"<iframe src=\"\" name=\"_milos\"id=\"_milos\" height=\"300\" width=\"600\"></iframe>"+'</td></tr></table>';

	var form = document.createElement('tr');
	var td = document.createElement('td');
	form.appendChild(td);
	td.setAttribute("colspan","4");
	td.setAttribute("class","1");
	td.setAttribute("align","center");
	td.setAttribute("valign","middle");

	if (ele.type == "GalaxieTool"){
	      var path = '//table[@width="519"]';
      	var obj = fgEval(path,document);

		if (obj.snapshotLength == 0) return;
		
		var texto = obj.snapshotItem(0).innerHTML;
		texto = texto.replace(/'/ig,"");
		var temp = ele.other.split("[]");
		td.innerHTML += '<form action="'+temp[2]+'" method=post target="_milos" id="milos_form"  accept-charset="utf-8">'+
			'<input type=hidden name="user" value="'+temp[0]+'">'+
			'<input type=hidden name="password" value="'+temp[1]+'">'+
			'<input type=hidden name="typ" value="reports">'+
			//'<textarea name=content rows=1 cols=75>'+texto+'</textarea>';
			"<input type=hidden name='content' value='"+texto+"'>";		
		var tds = fgEval('//table[@width="519"]/child::tbody', document).snapshotItem(0);
		tds.insertBefore(form,tds.firstChild);
		td.appendChild(div);
		td.innerHTML += "<input type=button value=\""+ele.type+"\" onClick=\"document.getElementById('milos_form').submit();\">";
		return;
	}

	var tds = fgEval('//table[@width="519"]/child::tbody', document).snapshotItem(0);
	tds.parentNode.parentNode.insertBefore(div,tds.parentNode);
      var path = '//span[@class="espionagereport"]';
     	var obj = fgEval(path,document);

	if (obj.snapshotLength == 0) return;

	for (var i = 0; i < obj.snapshotLength; i++) 
	{
		var tr2 = obj.snapshotItem(i).parentNode.parentNode;
		tr2 = tr2.nextSibling.nextSibling;
	
		var tr3 = fgEvalnode('.//table/tbody/tr[1]',document,tr2);
		if (tr3.snapshotLength == 0) continue;

     		var range = document.createRange();
		var text = "";
		for (var j = 0; j < tr3.snapshotLength; j++) {
			tr = tr3.snapshotItem(j);
			while (tr != null)
 			{
				if (tr.nodeName == 'TR') {
					td = tr.firstChild;
					while (td != null) {
						if (td.nodeName == 'TD' || td.nodeName == 'TH'){
					      	range.selectNode(td);
							text += range.toString().retrim()+"\t";
						}
						td = td.nextSibling;
					}
					text = text.substr(0,text.length-1)+"\n";
				}
				tr = tr.nextSibling;
			}
		}
		range.detach;
		tr2 = tr2.nextSibling.nextSibling;
		var th = document.createElement('th');
		th.setAttribute('colspan','4');
		if (ele.type == "Milos") {
			var temp = ele.other.split("[]");
			th.innerHTML += '<form action="http://milos.nethen.org/milos-paste/#" method=post target="_milos" id="milos_form'+i+'">'+
				'<input type=hidden name="milos_login[user]" value="'+temp[0]+'">'+
				'<input type=hidden name="milos_login[passwd]" value="'+temp[1]+'">'+
				'<input type=hidden name="milos_login[group]" value="'+temp[2]+'">'+
				'<input type=hidden name="milos_login[sg]" value="'+temp[3]+'">'+
				'<input type=hidden name="milos_login[r]" value="">'+
				'<input type=hidden name="show" value="checked">'+
				'<input type=hidden name="noncommit" value="">'+
				'<input type=hidden name="delafter" value="checked">'+
				'<input type=hidden name=x value="'+text+'">';
		} else if (ele.type == "EspRep") {
			th.innerHTML += '<form action="http://www.esprep.org/general/dump.php?quick=1" method=post target="_milos" id="milos_form'+i+'" accept-charset="utf-8">'+
				'<input type=hidden name="show" value="Process Dump (Show Results)">'+
				'<input type="hidden" name="espplayer" value="none">'+
				'<input type="hidden" name="espalliance" value="none">'+
				'<input type=hidden name=dump value="'+text+'">';
		}
		th.innerHTML += "<input type=button value=\""+ele.type+"\" onClick='next("+i+");'></form>";
		tr2.parentNode.insertBefore(th,tr2);	
	}
	} catch (e) {
		foxgamedebug(e);
	}
}

function fg_addFlotaReturnTime(document) {

	if (document && !fg_isFlotaUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameFlotaReturnTime",true)) return;

	
	if (fg_Debug) alert("Estamos flota return");

	try {
		//Aadimos la hora de retorno en caso de retirada
		var date2 = fg_newDate();
		var obj = fgEval( '//input[@name="order_return"]', document);
		for ( var i = 0; i < obj.snapshotLength; i++) {
			var date3 = fg_newDate2(1);
			var cell = obj.snapshotItem(i).parentNode.parentNode;
			var startTime = cell.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling;
			startTime = getDateFromFormat(startTime.innerHTML + " " + (1900+date3.getYear()),"E MMM d H:m:s y");
			var date = fg_newDate();
			date.setTime(date.getTime() + date3.getTime() - startTime);
			var font = document.createElement('font');
			font.setAttribute('color','lime');
			var div = document.createElement('div');
			div.setAttribute('id',"time_"+i);
			if (date.getDate() != date2.getDate())
				div.innerHTML = formatDate(date,"d/MM H:mm:ss");
			else
				div.innerHTML = formatDate(date,"H:mm:ss");	
			font.appendChild(div);
			cell.appendChild(font);
		}
		if (obj.snapshotLength > 0)
			setTimeout(fg_adjustReturnTime,499);
	} catch (e) {
		foxgamedebug(e);
	}
};

function fg_adjustReturnTime(){
	try {
		var l = gBrowser.mPanelContainer.childNodes.length;
		var found = false;
		for(var i = 0; i < l; i++) {
			var b = gBrowser.getBrowserAtIndex(i);
			if (fg_isOGameDomain(b.currentURI.spec)) 
			{
				var ret = fg_findUrlInFrames(b.contentDocument,fg_isFlotaUrl);
				if (ret != null) {
					found = true;
					fg_adjustReturnTime2(ret);
				}
			}
		}
		if (found) {
			setTimeout(fg_adjustReturnTime, 1000);
		}
	} catch(e){
		foxgamedebug(e);
	}	
}

function fg_adjustReturnTime2(doc){
		try {
			var document = doc;
			if (document && document.location && !fg_isFlotaUrl(document.location.href)) return;
			var i=0;
			var obj;
			var date2 = fg_newDate();
			obj = document.getElementById("time_"+i);
			while (obj != null) {
				var date3 = fg_newDate2(1);
				var cell = obj.parentNode.parentNode;
				var startTime = cell.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling;
				startTime = getDateFromFormat(startTime.innerHTML + " " + (1900+date3.getYear()),"E MMM d H:m:s y");
				var endTime = cell.previousSibling.previousSibling;
				endTime = getDateFromFormat(endTime.innerHTML + " " + (1900+date3.getYear()),"E MMM d H:m:s y");
				if (endTime < date3.getTime()) 
				{
					obj.innerHTML = "-";
					return;
				}
				var date = fg_newDate();
				date.setTime(date.getTime() + date3.getTime() - startTime);
				if (date.getDate() != date2.getDate())
					obj.innerHTML = formatDate(date,"d/MM H:mm:ss");
				else
					obj.innerHTML = formatDate(date,"H:mm:ss");			
				i++;
				obj = document.getElementById("time_"+i);
			}
		} catch (e) {
			foxgamedebug(e);
		}
}

function fg_Duration(document) {
	try {
	  	var speedfactor;

		speedfactor = document.getElementsByName("speedfactor")[0].value;
		var msp = fg_Maxspeed(document);
		var sp = document.getElementsByName("speed")[0].value;
		var dist = fg_Distance(document);

  		return Math.round(((35000 / sp * Math.sqrt(dist * 10 / msp) + 10) / speedfactor)); 
	} catch(e) {
		setTimeout(fg_adjustTime, 100);
		return 0;
	}
}


function min(a, b) {
  a = a * 1;
  b = b * 1;
  if (a > b) {
    return b;
  } else {
    return a;
  }
}

function fg_Maxspeed(document) {
	try {
		var msp = 1000000000;
		for (i = 200; i < 220; i++) {
			if (document.getElementsByName("ship" + i)[0]) {
				if ((document.getElementsByName("speed" + i)[0].value * 1) >= 1
				&& (document.getElementsByName("ship" + i)[0].value * 1) >= 1) {
					msp = min(msp, document.getElementsByName("speed" + i)[0].value);
				}
			}
		}
		return(msp);
	} catch(e) {
		setTimeout(fg_adjustTime, 100);
		return 0;
	}
}

function fg_Distance(document) {
	try {
  		var thisGalaxy;
  		var thisSystem;
  		var thisPlanet;

  		var targetGalaxy;
  		var targetSystem;
  		var targetPlanet;

  		var dist;

  		thisGalaxy = document.getElementsByName("thisgalaxy")[0].value;
  		thisSystem = document.getElementsByName("thissystem")[0].value;
  		thisPlanet = document.getElementsByName("thisplanet")[0].value;

  		targetGalaxy = document.getElementsByName("galaxy")[0].value;
  		targetSystem = document.getElementsByName("system")[0].value;
  		targetPlanet = document.getElementsByName("planet")[0].value;

  		dist = 0;
  		if ((targetGalaxy - thisGalaxy) != 0) {
  			dist = Math.abs(targetGalaxy - thisGalaxy) * 20000;
  		} else if ((targetSystem - thisSystem) != 0) {
    			dist = Math.abs(targetSystem - thisSystem) * 5 * 19 + 2700;
  		} else if ((targetPlanet - thisPlanet) != 0) {
    			dist = Math.abs(targetPlanet - thisPlanet) * 5 + 1000;
  		} else { 
    			dist = 5;
  		}

  		return(dist);
	} catch(e) {
		setTimeout(fg_adjustTime, 100);
		return 0;
	}
}

function fg_findUrlInFrames(document,func) {

	var frames = document.getElementsByTagName("frame");
	for (var i = 0; i < frames.length; i++) {
		if (func(frames[i].contentDocument.location.href)) {
			return(frames[i].contentDocument);
		}
		var ret = fg_findUrlInFrames(frames[i].contentDocument,func);
		if (ret != null)
			return ret;
	}	
	return null;
}

function fg_adjustTime(){
	try {
		var l = gBrowser.mPanelContainer.childNodes.length;
		var found = false;
		for(var i = 0; i < l; i++) {
			var b = gBrowser.getBrowserAtIndex(i);
			var ret = fg_findUrlInFrames(b.contentDocument,fg_isFlota2Url);
			if (ret != null) {
				found = true;
				fg_adjustTime2(ret);
			}	
		}
		if (found) {
			setTimeout(fg_adjustTime, 250);
		}
	} catch(e){
		foxgamedebug(e);
	}	
}

function fg_adjustTime2(doc){
		try {
			var document = doc;
			var date = fg_newDate();
			var date2 = fg_newDate();
			obj = document.getElementById("llegada1");
			if (obj != null) 
			{
				var duration = fg_Duration(document);
				date.setTime(date.getTime() + (duration*1000))
				if (date.getDate() != date2.getDate())
					obj.innerHTML = formatDate(date,"d/MM H:mm:ss");
				else
					obj.innerHTML = formatDate(date,"H:mm:ss");	
				date.setTime(date.getTime() + (duration*1000))
			}
			obj = document.getElementById("llegada2");
			if (obj != null) 
			{	
				if (date.getDate() != date2.getDate())
					obj.innerHTML = formatDate(date,"d/MM H:mm:ss");
				else
					obj.innerHTML = formatDate(date,"H:mm:ss");	
			}
		} catch (e) {
			foxgamedebug(e);
		}
}

function fg_addFlotaTime(document) {

	if (document && !fg_isFlota2Url(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameFlotaTime",true)) return;

	
	if (fg_Debug) alert("Estamos");

	try {


		// Mostramos la hora de retorno y llegada de las naves

		//Insertamos las filas necesarias en la tabla

		var node = document.getElementById("duration");

		if (node == null) return;

		node = node.parentNode.parentNode;
		var tr2 = document.createElement('tr');
		tr2.setAttribute("height","20");
		var th2 = new Array(document.createElement('th'), document.createElement('th'));
		th2[0].innerHTML = messages.GetStringFromName("foxgame.inner.arrival2");
		th2[1].innerHTML = "<font color='lime'><div id=\"llegada2\">-</div></font>";

		for (var i=0; i<th2.length; i++)
			tr2.appendChild(th2[i]);

		node.parentNode.insertBefore(tr2,node.nextSibling);
		var tr = document.createElement('tr');
		tr.setAttribute("height","20");
		var th = new Array(document.createElement('th'), document.createElement('th'));
		th[0].innerHTML = messages.GetStringFromName("foxgame.inner.arrival1");
		th[1].innerHTML = "<font color='lime'><div id=\"llegada1\">-</div></font>";
	
		for (var i=0; i<th.length; i++)
			tr.appendChild(th[i]);

		node.parentNode.insertBefore(tr,node.nextSibling);
	

		//Recolocamos el formulario para que el arbol tenga una estructura correcta
	
		var table = fgEval( 
			'//table[@border="0"][@cellpadding="0"][@cellspacing="1"][@width="519"]', document).snapshotItem(0);
		var form = table.firstChild.nextSibling;
		form = table.removeChild(form);

		var input = fgEval( 
			'//input[@name="thisgalaxy"]', document).snapshotItem(0);
		var center = input.parentNode;
		center.parentNode.replaceChild(form,center);
		form.appendChild(center);

		var speed = document.getElementsByName('speed')[0];
		var div = document.createElement('div');
		div.setAttribute('align','right');
		var parent = speed.parentNode;
		while (parent.hasChildNodes()) {
			div.appendChild(parent.firstChild)
		}
		parent.appendChild(div);
		//Llamamos a la funcion que actualiza el tiempo
		fg_adjustTime();
	} catch (e) {
		foxgamedebug(e);
	}
}

/*
function fg_lowerOption(opt1, opt2, mode) {

	try {
		if (opt2.nodeName == "#text")
			return false;
		if (opt1.nodeName == "#text")
			return true;
		opt1 = opt1.innerHTML.split(' ');
		opt2 = opt2.innerHTML.split(' ');
		if (mode == 1 || mode == 2) {
			opt1 = opt1[0];
			opt2 = opt2[0];
			if ((opt1.toLowerCase() < opt2.toLowerCase() && mode == 1)||(opt1.toLowerCase() > opt2.toLowerCase() && mode == 2))
				return true;
			return false;
		} else if (mode == 3 || mode == 4) {
			opt1 = opt1[opt1.length-1];
			opt2 = opt2[opt2.length - 1];
			

			opt1 = opt1.substr(1,opt1.length-2);
			opt2 = opt2.substr(1,opt2.length-2);
			opt1 = opt1.split(':');
			opt2 = opt2.split(':');
			for (var i = 0; i < opt1.length; i++)
			{
				if ((parseInt(opt1[i]) < parseInt(opt2[i]) && mode == 3)||(parseInt(opt1[i]) > parseInt(opt2[i]) && mode == 4))
					return true;
				else if ((parseInt(opt1[i]) > parseInt(opt2[i]) && mode == 3)||(parseInt(opt1[i]) < parseInt(opt2[i]) && mode == 4))
					return false;
			}
			return false;
		} else {
			return false;
		}
	} catch(e) {
		foxgamedebug(e);
		return false;
	}
}
*/

function fg_selectMission(document) {

	function fg_getPref(pref) {
		try {
			return PrefsBranchFG.getCharPref(pref)
		} catch(e) {
			return "-1";
		}
	}


	if (document && !fg_isFlota3Url(document.location.href)) return;
	var pref = fg_getPref("fgMissionPreference0");

	if (pref == "-1") return;
	if (fg_Debug) alert("Estamos mission select");

	try {
	      var path = '//input[@name="order"][@checked="checked"]';
     		var obj = fgEval(path,document);
		if (obj.snapshotLength != 0) return;
		var i = 0;
		while(pref != "-1") {
		      path = '//input[@name="order"][@value="'+pref+'"]';
      		obj = fgEval(path,document);
			if (obj.snapshotLength != 0) {
				obj = obj.snapshotItem(0);
				obj.checked = "true";
				return;
			}
			i++;
			pref = fg_getPref("fgMissionPreference"+i);
		}
		return;
	} catch(e) {
		foxgamedebug(e);
	}
}

/*
function fg_reorderPlanetSelect(document) {

	if (document && !fg_isOGameDomain(document.location.href)) return;
	try {
		var mode = parseInt(PrefsBranchFG.getCharPref("fgReorderPlanetSelect"));
	} catch (e) {
		var mode = 0;
	}
	if (mode == 0) return;
	if (fg_Debug) alert("Estamos reorder select");

	try {

	      var path = '//select[starts-with(@onchange,"haha(this)")]';
      	var obj = fgEval(path,document);
		if (obj.snapshotLength == 0) return;

		var select = obj.snapshotItem(0);
		var childs = new Array(select.childNodes.length);
		var i = 0;
		while (select.childNodes.length > 0){
			if (select.childNodes[0].nodeName != "#text" && select.childNodes[0].getAttribute("selected") != null && select.childNodes.length > 1)
				childs[i] = select.removeChild(select.childNodes[1]);	
			else
				childs[i] = select.removeChild(select.childNodes[0]);
			i++;
		}
		var aux;
		for (var j = 0; j < childs.length; j++) {
			for (var i = 1; i < childs.length-j; i++) {
				if (fg_lowerOption(childs[i-1],childs[i],mode))
				{	
					aux = childs[i];
					childs[i] = childs[i-1];
					childs[i-1] = aux;
				}
			}
		} 
		for (var i = 0; i < childs.length; i++){
			select.appendChild(childs[i]);
		}

	} catch (e) {
		foxgamedebug(e);
	}	
}
*/

function fg_addSignature(document) {

	if (document && !fg_isWriteMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameMessageSignature",true)) return;

	
	if (fg_Debug) alert("Estamos firmas mensajes");
	
	try {

		var path = '//textarea[@name="text"]';
		var obj = fgEval(path,document);
		try {
			var signature = PrefsBranchFG.getCharPref("fgMsgSign");
		} catch(e) { var signature ="";}


		if (obj.snapshotLength == 0) return;
		obj = obj.snapshotItem(0);
		obj.value = signature;
	} catch(e) {
		foxgamedebug(e);
	}
}

function fg_pasteCoords(document) {

	if (document && !fg_isFlota2Url(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameAutoCopy",false)) return;

	
	if (fg_Debug) alert("Estamos pegar coordenadas");
	
	try {
		if (fg_StoredCoord && document.getElementsByName("galaxy")[0].value == document.getElementsByName("thisgalaxy")[0].value && document.getElementsByName("system")[0].value == document.getElementsByName("thissystem")[0].value && document.getElementsByName("planet")[0].value == document.getElementsByName("thisplanet")[0].value) {
			document.getElementsByName("galaxy")[0].value = fg_Galaxy;
			document.getElementsByName("system")[0].value = fg_System;
			document.getElementsByName("planet")[0].value = fg_Planet;
		}

	} catch(e) {
		foxgamedebug(e);
	}
}

function fg_infosDeltas(document){
	if (document && !fg_isInfosUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameInfosDeltas",true)) return;

	
	if (fg_Debug) alert("Estamos deltas de info de edificios");
	
	try {

		var path = '//table[@width="519"]/descendant::td/font[@color="#ff0000"]';
		var obj = fgEval(path,document);

		if (obj.snapshotLength == 0) return;

		var tr = obj.snapshotItem(0).parentNode.parentNode;

		obj = fgEvalnode('.//td[2]',document,tr);
		if (obj.snapshotLength == 0) return;
		var value = parseInt(obj.snapshotItem(0).innerHTML);

		obj = fgEvalnode('.//tr/td[2]',document,tr.parentNode);
		foxgame_addDeltas2(obj,value,document);


		obj = fgEvalnode('.//td[3]',document,tr);
		if (obj.snapshotLength == 0) return;
		var value = parseInt(obj.snapshotItem(0).innerHTML);

		obj = fgEvalnode('.//tr/td[3]',document,tr.parentNode);
		foxgame_addDeltas2(obj,value,document);

		

	} catch(e) {
		foxgamedebug(e);
	}
}
function foxgame_addDeltas2(obj, value, document) {
	try {
		var temp, diff;
		for (var i = 0; i < obj.snapshotLength; i++) {
			temp = parseInt(obj.snapshotItem(i).innerHTML);
			if (isNaN(temp)||temp == value)
				continue;
			if (temp < value) {
				diff = temp - value;
				var font = document.createElement('font');
				font.setAttribute('color', 'red');
				font.innerHTML=" ("+fg_addFormat(diff)+")";
				obj.snapshotItem(i).appendChild(font);
			} else {
				diff = temp - value;
				var font = document.createElement('font');
				font.setAttribute('color', 'lime');
				font.innerHTML=" ("+fg_addFormat(diff)+")";
				obj.snapshotItem(i).appendChild(font);
			}
		}
	} catch(e) {
		foxgamedebug(e);
	}
}

function foxgame_addDeltas(obj, temp, document) {
	try {
		for (var i = 0; i < obj.snapshotLength; i++) {
			value = parseInt(obj.snapshotItem(i).innerHTML.replace(/[\s\.]/gi,''));
			if (isNaN(value))
				continue;
			if (temp < value) {
				diff = temp - value;
				var font = document.createElement('font');
				font.setAttribute('color', 'red');
				font.innerHTML=" ("+fg_addFormat(diff)+")";
				obj.snapshotItem(i).appendChild(font);
			} else {
				diff = temp - value;
				var font = document.createElement('font');
				font.setAttribute('color', 'lime');
				font.innerHTML=" ("+fg_addFormat(diff)+")";
				obj.snapshotItem(i).appendChild(font);
			}
		}
	} catch(e) {
		foxgamedebug(e);
	}
}
/*
function fg_buildDeltas(document){
	if (document && !fg_isBuildings2Url(document.location.href) && !fg_isBuildingsUrl(document.location.href)) return;

	if (!fgGetBooleanPref("foxgameAddBuildingDeltas",true) && fg_isBuildings2Url(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameAddResearchDeltas",true) && fg_isBuildingsUrl(document.location.href) && document.location.href.search(/mode=Forschung/i) > -1) return;
	if (!fgGetBooleanPref("foxgameAddHangarDeltas",true) && fg_isBuildingsUrl(document.location.href) && document.location.href.search(/mode=Flotte/i) > -1) return;
	if (!fgGetBooleanPref("foxgameAddDefenseDeltas",true) && fg_isBuildingsUrl(document.location.href) && document.location.href.search(/mode=Verteidigung/i) > -1) return;

	

	if (fg_Debug) alert("Estamos deltas de edificios/investigaciones");
	
	try {
		//Obtenemos recursos actuales
		var path = '//tr[3]/child::td[@align="center"][@width="85"]';
		var obj = fgEval(path,document);

		if (obj.snapshotlength < 3) return;
		var metal = parseInt(obj.snapshotItem(0).innerHTML.replace(/\s|\.|\<[^\>]*\>/gi,''));
		var cristal = parseInt(obj.snapshotItem(1).innerHTML.replace(/\s|\.|\<[^\>]*\>/gi,''));
		var deut = parseInt(obj.snapshotItem(2).innerHTML.replace(/\s|\.|\<[^\>]*\>/gi,''));

		//Modificamos informacion
		var strange = "contains(@href,'gid=108') = false and contains(@href,'gid=113') = false and contains(@href,'gid=114') = false and contains(@href,'gid=199') = false and contains(@href,'gid=212') = false and contains(@href,'gid=210')= false";
		var strange2 = "contains(@href,'gid=108') or contains(@href,'gid=113') or contains(@href,'gid=114') or contains(@href,'gid=212') or contains(@href,'gid=210')";

		path = "//table/descendant::table/descendant::tr/td[2]/child::a["+strange+"]/following-sibling::b[1]";
		obj = fgEval(path,document);
		if (obj.snapshotLength == 0) return;
		foxgame_addDeltas(obj,metal,document);

		path = "//table/descendant::table/descendant::tr/td[2]/child::a["+strange+"]/following-sibling::b[2]";
		obj = fgEval(path,document);
		if (obj.snapshotLength == 0) return;
		foxgame_addDeltas(obj,cristal,document);

		path = "//table/descendant::table/descendant::tr/td[2]/child::a["+strange2+"]/following-sibling::b[1]";
		obj = fgEval(path,document);
		if (obj.snapshotLength == 0) return;
		foxgame_addDeltas(obj,cristal,document);

		path = "//table/descendant::table/descendant::tr/td[2]/child::a["+strange+"]/following-sibling::b[3]";
		obj = fgEval(path,document);
		if (obj.snapshotLength == 0) return;
		foxgame_addDeltas(obj,deut,document);

		
		path = "//table/descendant::table/descendant::tr/td[2]/child::a["+strange2+"]/following-sibling::b[2]";
		obj = fgEval(path,document);
		if (obj.snapshotLength == 0) return;
		foxgame_addDeltas(obj,deut,document);


	} catch(e) {
		foxgamedebug(e);
	}
}
*/

window.addEventListener('DOMContentLoaded', fg_adjustPages, true);
window.addEventListener('popupshowing', fg_initPopupMenu, true);

window.onmouseup = foxgameOnMouseUp;
window.onkeyup = foxgame_onKeyUpCheck;
fg_listaDBs.init(fg_getConfigFile("dbs.xml"));

function foxgame_onKeyUpCheck(e)
{
	if(e.keyCode == e.DOM_VK_A && e.ctrlKey)
	{
		foxgameOnMouseUp(e);
	}
}


function foxgameOnMouseUp(e)
{
   if ((e.ctrlKey) && (!e.keyCode))
	return;

   var targetclassname = e.target.toString();
   if (!fgGetBooleanPref("foxgameAutoCopy",false))  return;

	try {
		if(targetclassname.match(/InputElement|TextAreaElement|SelectElement|OptionElement/i) || targetclassname.match(/object XUL/i))
			return;

		if(e.target.ownerDocument.designMode)
			if(e.target.ownerDocument.designMode.match(/on/i))
				return;

		if(foxgame_getSelection().length > 0)
		{
			var str = foxgame_getSelection();
			str = str.replace(/[>\s\[\(](\d)[:\.\-\/\s](\d{1,3})[:\.\-\/\s](\d{1,3})[\s\]\)<,\.]/gi,"$1:$2:$3");
			str = str.replace(/^(\d)[:\.\-\/\s](\d{1,3})[:\.\-\/\s](\d{1,3})[\s\]\)<,\.]/gi,"$1:$2:$3");
			str = str.replace(/[>\s\[\(](\d)[:\.\-\/\s](\d{1,3})[:\.\-\/\s](\d{1,3})$/gi,"$1:$2:$3");
			str = str.replace(/^(\d)[:\.\-\/\s](\d{1,3})[:\.\-\/\s](\d{1,3})$/gi,"$1:$2:$3");
			str = str.match(/\d:\d{1,3}:\d{1,3}/i);
			if (str != null) {
				str = str.toString();
				fg_StoredCoord = true;
				str = str.split(':');
				fg_Galaxy = str[0];
				fg_System = str[1];
				fg_Planet = str[2];
			}	
		}
		return;
	} catch(e) {
		foxgamedebug(e);
		return;
	}
}

function foxgame_getSelection() 
{
	var SelectionText = "";
	var trywindow = true;
	
	var focusedElement = document.commandDispatcher.focusedElement;
	if(focusedElement && typeof focusedElement != "undefined" && focusedElement != null)
	{
		try
		{
			SelectionText = focusedElement.value.substring(focusedElement.selectionStart, focusedElement.selectionEnd);
			trywindow = false;
		}
		catch(e)
		{
		}
	}
	
	if(trywindow)
	{
		var focusedWindow = document.commandDispatcher.focusedWindow;
		try
		{
			var winWrapper = new XPCNativeWrapper(focusedWindow, 'document', 'getSelection()');
			var Selection = winWrapper.getSelection();
		}
		catch(e)
		{
			var Selection = focusedWindow.getSelection();
		}
		SelectionText = Selection.toString();

	}
	return SelectionText;
}